/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: ENV_SDUP.C $
   $Locker:  $	$Name:  $	$State: Exp $

	char *env_strdup(word segm, const int stringNr)

	Copies the stringNr'th string (1st string is 0) of the environment
	segm into the buffer newly malloc()'ed.

	If segm == 0, the current used environment is processed.

	Return:
		NULL: failure: stringNr too high, no environment, no memory
		else: pointer to the buffer

	Target compilers: Micro-C v3.13, v3.14; Borland C v2, v3.1, v4.52

*/

#include "initsupl.inc"

#ifndef _MICROC_
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#endif
#include "environ.h"
#include "fmemory.h"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: ENV_SDUP.C 1.3 1998/08/19 02:40:21 ska Exp $";
#endif

char *env_strdup(word segm, const int stringNr)
{	char *buf;
	word ofs;
	unsigned length;

	if(!segm && !(segm = env_glbSeg))
		return NULL;						/* no environment at all */

	if(!(ofs = env_string(segm, stringNr))
	 || ofs == env_firstFree(segm))
		return NULL;						/* string number too high */

	if((buf = malloc(length = env_varlen(segm, ofs))) != NULL)
		_fmemcpy(TO_FP(buf), MK_FP(segm, ofs), length);

	return buf;
}
