/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: FMEMCMP.C $
   $Locker:  $	$Name:  $	$State: Exp $

	int _fmemcmp(dseg, dofs, sseg, sofs, length)

	Compares the memory areas of length bytes at sseg:sofs and dseg:dofs.

	Returns: == 0: both areas are equal
			  > 0: 1st area > 2nd area
			  < 0: 1st area < 2nd area

	Target compilers: Micro-C v3.13, v3.14; Borland C v2, v3.1, v4.52

*/

#include "initsupl.inc"

#ifdef _MICROC_
#include <portable.h>

int _fmemcmp(unsigned const dseg, unsigned dofs
 , unsigned const sseg, unsigned sofs, unsigned length)
{	int d;

	if(!length)
		return 0;

	while((d = peekb(dseg, dofs++) - peekb(sseg, sofs++)) == 0 && --length);

	return d;
}

#else
#ifdef _PAC_NOCLIB_
#include <portable.h>

int _fmemcmp(const void far * const s1, const void far * const s2
	, unsigned length)
{	byte far *p;
	byte far *q;
	int d;

	if(!length)
		return 0;

	p = s1;
	q = s2;
	while((d = *p++ - *q++) != 0 && --length);
	return d;
}
#endif
#endif
