/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: FSTRCMPI.C $
   $Locker:  $	$Name:  $	$State: Exp $

	int _fstrcmpi(dseg, dofs, sseg, sofs)

	Compares the strings at sseg:sofs and dseg:dofs, case-insensitive.

	Returns: == 0: both strings are equal
			  > 0: 1st string > 2nd string (or longer)
			  < 0: 1st string < 2nd string (or smaller)

	Target compilers: Micro-C v3.13, v3.14; Borland C v2, v3.1, v4.52

*/

#include "initsupl.inc"

#ifdef _MICROC_
#include <portable.h>

int _fstrcmpi(unsigned const dseg, unsigned const dofs
 , unsigned const sseg, unsigned const sofs)
{	int d;
	char c;

	while((d = (c = toupper(peekb(dseg, dofs++)))
	 - toupper(peekb(sseg, sofs++))) == 0 && c);

	return d;
}

#endif
